<?php
class admindodavatelController extends baseadminController {

  function __construct() {
    $this->controller_name = 'Dodavatelé';
    $this->controller_fname = 'admindodavatel';
    $this->controller_info = 'Modul umožňuje udržovat informace o dodavatelích zboží, kontaktech a zboží, které dodávají. 
Je používán výhradne pro interní potřeby. Zákazníkům nejsou žádné informace z tohoto modulu dostupné.';
    $this->entita_classname = 'Dodavatel';
    parent::__construct();
  }

  public function seznam($args) {

    $table_id = 'seznamDodavatele';
    $entita = new $this->entita_classname();

    $this->registry->jscript->addJqFunction('"#'.$table_id.'"', 'tablesorter','','','','','','document_ready');

    $query = $entita->getAllQuery();
    $filtr_query = array();
    $this->setFilter($filtr_query, $entita);
    $this->myOrder($filtr_query, $entita);
    $strankovani = $this->addLimit($query, $filtr_query ,$entita);
		$query = array_merge($query,$filtr_query);

    $result = dibi::query($query);
    $zaznamy = $result->fetchAll();
    unset($result);

    array_walk($zaznamy,
      'Tools::addLink',
      array('UPRAVIT' => array(
          'link' => Tools::controllerlink($this->controller_fname, 'upravit'),
          'addindex' => 'ID',
          'text'	 => ICO_UPRAVIT
        ),
					'SMAZAT' => array(
          'link' => Tools::controllerlink($this->controller_fname, 'smazat'),
          'addindex' => 'ID',
          'text'	 => ICO_SMAZAT
        )
      )
    );

    $hlavicka = array(
      'ID' => 'Id',
      'NAZEV' => 'Název',
      'POPIS' => 'Popis',
      'S_NAZEV' => 'Stav',
      'UPRAVIT' => '',
    	'SMAZAT' => ''
    );
  
    $obsah_css = array(
      'ID' => 'a_c',
      'S_NAZEV' => 'a_c',
      'UPRAVIT' => 'a_c',
			'SMAZAT' => 'a_c'
    );
    
    $hlavicka_css = array(
      'UPRAVIT' => 'nosort',
			'SMAZAT' => 'nosort'
    );
    $this->thCss($hlavicka_css);

    $this->html = $this->getTable($table_id, $hlavicka, $zaznamy,
      array('class' => 'seznam tablesorter', 'summary' => $this->controller_name ),
      $obsah_css, array('ID', 'SMAZAT'), $hlavicka_css, 'multisort', $entita->filtry, false
    );
		$this->html .= '<div class="strankovani">'.$strankovani.'</div></form>';
    $this->setView();
/*

    unset($result); //'class' => 'seznam',
    $this->html = $this->getTable($table_id, $hlavicka, $entita,
      array('class' => 'seznam tablesorter', 'summary' => $this->controller_name ),
      $obsah_css, array('ID', 'UPRAVIT'), $hlavicka_css, 'multisort'
    );
    
    $this->setView();
*/
  }

  public function pridat($args) {
    
    $form_id = 'PridatDodavateleForm';
    $entita = new $this->entita_classname();

    if ($this->registry->form_send) {
      if (Validate::entita($entita,true) !== false) {
        $entita->setFromPost();
        $entita->insert();
        Tools::setMessage('Záznam '.$entita->nazev.' byl přidán', CSS_MESS, 1);
        
        if (isset($_POST['uloz_pokracuj'])) {
        	$redirect = Tools::ControllerLink('adminadresa','pridat', array ('dodavatel', $entita->id) );
        	Tools::setMessage('Dodavatel '.$entita->nazev.' byl přidán.
          	<br /> Nyní můžete zadat adresu dodavatele.', CSS_MESS, 1);
        }
        elseif (isset($_POST['uloz_seznam'])) {
        	$redirect = Tools::ControllerLink($this->controller_fname,'seznam');
        }
        else {
          $redirect = Tools::ControllerLink($this->controller_fname,'upravit', array( $entita->id) );          
        }

        Tools::redirect($redirect);
        die;

      }
      else {
        $valid_err = Validate::error();
        Tools::setMessage('Špatně vyplněné údaje'.$valid_err, 'err_mess', CSS_ERR);
      }
    }

    $form = new Form($form_id, '', 'post', array('class' => 'myForm'));
    $form->openFieldset('Přidat dodavatele');
    $form->addLabel('Jméno', 'nazev', array(), 'Označení dodavatele');
    $form->addInput('text', 'nazev', MY,array(), $entita->validate['nazev'],true);
    $form->addLabel('Popis', 'popis' );
    $form->addTextarea('popis', MY, true, array('class' => 'stredni'));
    $form->addTag('br');
    $form->addLabel('Stav', 'stav' );
    $form->stateSelect($entita, true);

    $form->openTag('div', array('class' => 'bb_l'));
    $form->addTag('hr',array('class' => 'fcleaner '));
    $form->addInput('submit', 'uloz_pokracuj', 'Uložit a vložit adresu');
    $form->addInput('submit', 'uloz_seznam', 'Uložit a zobrazit seznam');
    $form->addInput('submit', 'uloz', 'Uložit a zobrazit');
    $form->closeTag();
    $form->closeFieldset();
    $form->closeForm();

    $this->html = $form->get();
    $this->setView('content.tpl');

  }

  public function upravit($args) {

    $id = @$args[0];
    $form_id = 'UpravitDodavateleForm';
    $entita = new $this->entita_classname();

    if ($this->registry->form_send) {
      if (Validate::entita($entita) !== false) {

        if (isset($_POST['uloz_seznam'])) {
          $redirect = Tools::ControllerLink($this->controller_fname,'seznam' );          
        }
        else {
          $redirect = Tools::ControllerLink($this->controller_fname,'upravit', array( $id) );
        }

        $entita->upravit($id,$form_id);
        Tools::setMessage('Záznam '.$entita->nazev.' byl upraven', '', 1);
        Tools::redirect($redirect);
        die;

      }
      else {
        $valid_err = Validate::error();
        Tools::setMessage('Špatně vyplněné údaje'.$valid_err, CSS_ERR);
      }
    }

    $form_value = $entita->loadByID($id, true, $this->registry->postRestore);

    $form = new Form($form_id, '', 'post', array('class' => 'myForm'));
    $form->setEntitaRef($entita);
    $form->setValue($form_value);
    $form->openFieldset('Upravit dodavatele');
    $form->addLabel('Jméno', 'nazev', array(), 'Označení dodavatele');
    $form->addInput('text', 'nazev', MY,array(), $entita->validate['nazev']);
    $form->addTag('br');
    $form->addLabel('Popis', 'popis' );
    $form->addTextarea('popis', MY, true, array('class' => 'stredni'));
    $form->addTag('br');
    $form->addLabel('Stav', 'stav' );

    if ($form->stateSelect($entita) == true) {
      $form->addInput('hidden', HASH, MY);
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addTag('hr',array('class' => 'fcleaner '));
      $form->addInput('submit', 'uloz_seznam', 'Uložit a zobrazit seznam');
      $form->addInput('submit', 'uloz', 'Uložit a zobrazit');
      $form->closeTag();
    }
    else {
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addInnerHTML('Nemáte oprávnění pro modifikaci záznamu v uvedeném stavu.<br /><br />');
      $form->addInput('reset', 'reset', 'Vrátit změny');
      $form->closeTag();
    }
    $form->closeFieldset();
    $this->html = $form->get();
    
    $this->setView();
  }

  public function smazat($args) {

    $form_id = 'smazatDodavatele';
		$id = @$args[0];
		$entita = new $this->entita_classname();
		
		if ($this->registry->form_send) {
			$my_id = @$this->registry->$form_id;

			if ( $my_id == $id) {
				$entita->delete($id);
				Tools::setMessage('Záznam byl smazán', '', 1);
				Tools::redirect(Tools::controllerlink($this->controller_fname, 'seznam'));
			}
			else {
      	Tools::setMessage('Neoprávněný pokus o smazání položky!');
      	return $this->seznam(array());
      	die;
			}
		}
		
		$result = dibi::query('SELECT D.*,
  		(SELECT COUNT(*) FROM DOD_PROD DP
  			WHERE DP.ID_DOD = D.ID) AS PRODUKTY
			FROM [DODAVATEL] D
			WHERE D.ID = %i',$id);
		
		if (count($result) == 0) {
      Tools::setMessage('Požadovaný záznam neexistuje!');
      return $this->seznam(array());
    }

		$this->registry->addPersistent($form_id,$id, 2);
		$r = $result->fetchAll();
		$zaznam = $r[0];

    if ( $zaznam['PRODUKTY'] > 0 ) {
			$result = dibi::query('SELECT P.ID, P.NAZEV
				FROM [PRODUKT] P
  			WHERE P.ID_VYR = %i', $id);
			$r = $result->fetchAssoc('ID');
			
			$produkty = '<div class="warning"><h3>Dodavatel je uveden u následujících produktů</h3>';
			$produkty .= '<p><ul class="smazat">';
			foreach($r as $row) {
				$produkty .= '<li> #id: '.$row['ID'].' - '.$row['NAZEV'].'</li>';
			}
			$produkty .= '</ul>Chcete-li dodavatele odstranit, odeberte ji nejprve z uvedených produktů.</p>
			</div>';
		}

  	$form = new Form($form_id);
		$form->openFieldset('Smazat záznam');
		if ( $zaznam['PRODUKTY'] > 0 ) {
  		$form->openTag('h3');
  		$form->addInnerHTML('Dodavatele <b>'.$zaznam['NAZEV'].'</b> nelze smazat!');
  		$form->closeTag();
  		$form->addInnerHTML($produkty);
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addTag('hr',array('class' => 'fcleaner '));
      $form->openTag('a', array('href' => Tools::controllerlink($this->controller_fname,'seznam')));
      $form->addInput('button', 'reset', 'Zrušit');
      $form->closeTag();
      $form->closeTag();
		}
		else {
			$this->registry->addPersistent($form_id,$id, 2);
  		$form->openTag('h2');
  		$form->addInnerHTML('Chcete opravdu odstranit dodavatele <b>'.$zaznam['NAZEV'].'</b> (id: '.$zaznam['ID'].') ?');
  		$form->closeTag();
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addTag('hr',array('class' => 'fcleaner '));
      $form->addInput('submit', 'uloz', 'Smazat');
      $form->openTag('a', array('href' => Tools::controllerlink($this->controller_fname,'seznam')));
      $form->addInput('button', 'reset', 'Zrušit');
      $form->closeTag();
      $form->closeTag();
		}
    
    $this->html = $form->get();
    $this->setView('content.tpl');
  }

}
?>